(*You will need to set this to wherever sml sits on your machine*)
val sml_dir = "/cse/courses/misc_lang/linux/sml";

(*Some useful shortcuts*)
val cd = OS.FileSys.chDir;
val pwd = OS.FileSys.getDir;
val stdout = TextIO.stdOut;
val stdin = TextIO.stdIn;
val stderr = TextIO.stdErr;

(*Need to load in the yacc-related libararies and random utilities*)
let val cur_dir = pwd() in
 (
    cd(sml_dir ^ "/src/smlnj-lib/Util");
    use(sml_dir ^ "/src/smlnj-lib/Util/load");
    cd(sml_dir ^ "/src/ml-yacc/lib");
    CM.make'("sources.cm");
    cd(cur_dir)
 ) end;

use("ml_ast.ml");
use("ml.gen_parser.ml");
use("ml_print.ml");

fun test_pp_ml (fin,fout) =
    let	val out_stream =  TextIO.openOut(fout);	    
	val ml' = MLParse(fin)
    in
	(MLAst_Print.progPrint(out_stream,ml');
	 TextIO.closeOut(out_stream))
    end
