use("ml.mlyacc.sig");
use("ml.mllex.sml");
use("ml.mlyacc.sml");
	 
structure MLLrVals = 
    MLLrValsFun(structure Token = LrParser.Token);
    
structure MLLex =
    MLLexFun(structure Tokens = MLLrVals.Tokens);

structure MLParser =
    Join(structure ParserData = MLLrVals.ParserData
	 structure Lex = MLLex
	 structure LrParser=LrParser);


val MLInvoke = fn lexstream =>
    let val print_error = fn (s,i:int,_) =>
	TextIO.output(TextIO.stdOut,"Error, line " ^
                      (Int.toString i) ^ ", " ^ s ^ "\n")
    in MLParser.parse(0,lexstream,print_error,())
    end;

fun MLParse(filename) = 
    let val infile = TextIO.openIn(filename)
	val lexer = MLParser.makeLexer (fn _ => TextIO.inputLine infile)
	val (result,_) = MLInvoke lexer
    in 
	result
    end;

