signature ML_TOKENS =
sig
type ('a,'b) token
type svalue
val STRING: (string) *  'a * 'a -> (svalue,'a) token
val BOOL: (bool) *  'a * 'a -> (svalue,'a) token
val INT: (int) *  'a * 'a -> (svalue,'a) token
val ID: (MLAst.id) *  'a * 'a -> (svalue,'a) token
val EXCEPTION:  'a * 'a -> (svalue,'a) token
val OPEN:  'a * 'a -> (svalue,'a) token
val STRUCT_KYWD:  'a * 'a -> (svalue,'a) token
val STRUCTURE:  'a * 'a -> (svalue,'a) token
val STAR_RPAREN:  'a * 'a -> (svalue,'a) token
val LPAREN_STAR:  'a * 'a -> (svalue,'a) token
val FN:  'a * 'a -> (svalue,'a) token
val ANDB:  'a * 'a -> (svalue,'a) token
val ORB:  'a * 'a -> (svalue,'a) token
val XORB:  'a * 'a -> (svalue,'a) token
val LSHIFT:  'a * 'a -> (svalue,'a) token
val RSHIFT:  'a * 'a -> (svalue,'a) token
val TILDE:  'a * 'a -> (svalue,'a) token
val NOT:  'a * 'a -> (svalue,'a) token
val ORELSE:  'a * 'a -> (svalue,'a) token
val ANDALSO:  'a * 'a -> (svalue,'a) token
val LT_GT:  'a * 'a -> (svalue,'a) token
val GT:  'a * 'a -> (svalue,'a) token
val LT:  'a * 'a -> (svalue,'a) token
val GEQ:  'a * 'a -> (svalue,'a) token
val LEQ:  'a * 'a -> (svalue,'a) token
val EQUALS:  'a * 'a -> (svalue,'a) token
val MOD:  'a * 'a -> (svalue,'a) token
val DIV:  'a * 'a -> (svalue,'a) token
val TIMES:  'a * 'a -> (svalue,'a) token
val MINUS:  'a * 'a -> (svalue,'a) token
val PLUS:  'a * 'a -> (svalue,'a) token
val STATIC_KYWD:  'a * 'a -> (svalue,'a) token
val RPAREN:  'a * 'a -> (svalue,'a) token
val COLON:  'a * 'a -> (svalue,'a) token
val SEMI_COLON:  'a * 'a -> (svalue,'a) token
val COMMA:  'a * 'a -> (svalue,'a) token
val LPAREN:  'a * 'a -> (svalue,'a) token
val END:  'a * 'a -> (svalue,'a) token
val LET:  'a * 'a -> (svalue,'a) token
val ELSE:  'a * 'a -> (svalue,'a) token
val THEN:  'a * 'a -> (svalue,'a) token
val IF:  'a * 'a -> (svalue,'a) token
val SKIP:  'a * 'a -> (svalue,'a) token
val BAR:  'a * 'a -> (svalue,'a) token
val OP:  'a * 'a -> (svalue,'a) token
val UNDERSCORE:  'a * 'a -> (svalue,'a) token
val EQUALS_GT:  'a * 'a -> (svalue,'a) token
val CASE:  'a * 'a -> (svalue,'a) token
val FUN_KYWD:  'a * 'a -> (svalue,'a) token
val VAL_KYWD:  'a * 'a -> (svalue,'a) token
val AND:  'a * 'a -> (svalue,'a) token
val IN:  'a * 'a -> (svalue,'a) token
val OF:  'a * 'a -> (svalue,'a) token
val DATATYPE:  'a * 'a -> (svalue,'a) token
val WITHTYPE:  'a * 'a -> (svalue,'a) token
val TYPE_KYWD:  'a * 'a -> (svalue,'a) token
val STRING_KYWD:  'a * 'a -> (svalue,'a) token
val BOOL_KYWD:  'a * 'a -> (svalue,'a) token
val INT_KYWD:  'a * 'a -> (svalue,'a) token
val FUNCTION_APP:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_15:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_14:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_13:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_12:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_11:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_10:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_9:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_8:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_7:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_6:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_5:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_4:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_3:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_2:  'a * 'a -> (svalue,'a) token
val CASE_PREC_NTERM_1:  'a * 'a -> (svalue,'a) token
val EOF:  'a * 'a -> (svalue,'a) token
end
signature ML_LRVALS=
sig
structure Tokens : ML_TOKENS
structure ParserData:PARSER_DATA
sharing type ParserData.Token.token = Tokens.token
sharing type ParserData.svalue = Tokens.svalue
end
