structure MLAst_Print=
    struct
	open MLAst;
	val ind_width = 2;
	val and_width = 4;
	val bar_width = 2;
	val let_width = 4;
	
	fun progPrint(FH,prog(sds))= strdecsPrint(FH,0,sds)

	and strdecsPrint(FH,il,sds)=	    
	    ignore   
	    (List.foldl (fn(sd,(_,firstp))=> 
			 (((if firstp then  () else TextIO.output(FH,"\n\n"));
				strdecPrint(FH,il,sd)),
				false)) 
	     ((),true)  sds)	    	    
	    
	and strdecPrint(FH,il,structure_dec(id,struct'))=
	    (
	     TextIO.output(FH,"structure "^id^" = ");
	     structPrint(FH,il,struct')
	     )
	  | strdecPrint(FH,il,non_structure_dec(d))= decPrint(FH,il,d)

	and structPrint(FH,il,struct_dec(sds))=
	    (
	     printIndent(FH,il);
	     TextIO.output(FH,"\nstruct\n");
	     strdecsPrint(FH,il+ind_width,sds);
	     printIndent(FH,il);
	     TextIO.output(FH,"\nend")
	     )
	  | structPrint(FH,il,struct_name_copy(id))= TextIO.output(FH,id)
	  | structPrint(FH,il,functor_application(id,faa))= 
	    (
	     TextIO.output(FH,id^"(");
	     functorAppArgsPrint(FH,il,faa);
	     TextIO.output(FH,")")
	     )

	and  functorAppArgsPrint(FH,il,faa_struct(s))=
	    structPrint(FH,il,s)
	  |  functorAppArgsPrint(FH,il,faa_strdecs(sds))=
	    strdecsPrint(FH,il,sds)

	and decPrint(FH,il,val_dec(pebs))=
	    (
	     printIndent(FH,il); 
	     TextIO.output(FH,"val ");
	     patExpBindingsEqualsAndPrint(FH,il,pebs)
	     )
	  | decPrint(FH,il,fun_dec(fb))= 
	    (printIndent(FH,il); 
	     TextIO.output(FH,"fun ");
	     fbindPrint(FH,il,fb)
	     )
	  | decPrint(FH,il,type_dec(tb))= 
	    (printIndent(FH,il); 
	     TextIO.output(FH,"type ");
	     tbindPrint(FH,il,tb)
	     )
	  | decPrint(FH,il,datatype_dec(dtb,tb))=
	    (
	     printIndent(FH,il);
	     TextIO.output(FH,"datatype ");
	     dtbindPrint(FH,il+ind_width,dtb);
	     case tb of
		 tbind([]) =>		()
	       | _ =>
		     (TextIO.output(FH,"\n");
		      printIndent(FH,il);
		      TextIO.output(FH,"withtype\n");
		      tbindPrint(FH,il,tb))
		     )
	  | decPrint(FH,il,exception_dec(idtbs))=
	    (
	     printIndent(FH,il);
	     TextIO.output(FH,"exception\n");
	     idTypeBindingsOfAndPrint(FH,il+ind_width,idtbs)
	     )
	  | decPrint(FH,il,open_dec(ids))=
	    (
	     printIndent(FH,il);
	     TextIO.output(FH,"open\n");
	     idsAndPrint(FH,il+ind_width,ids)
	     )
	and fbindPrint(FH,il,fbind(fun_defs))=funDefAndListprint(FH,il,fun_defs)
	and funDefAndListprint(FH,il,fun_defs) =
	    ignore
	    (List.foldl (fn(f,(_,i))=> 
			 ((
			   (if (i=0) then   
				()
			    else 
				(printIndent(FH,il); TextIO.output(FH,"\nand ")));
				funDefPrint(FH,il+and_width,f)),
				i+1)) 
	     ((),0)  fun_defs)
	    
	and funDefPrint(FH,il,fun_def(id,ids,exp))=
	    (
	     idPrint(FH,il,id);
	     TextIO.output(FH,"( ");
	     idsCommaPrint(FH,il,ids);
	     TextIO.output(FH," ) = \n");
	     printIndent(FH,il+ind_width);
	     expPrint(FH,il+ind_width,exp)
	     )
	    
	and   tbindPrint(FH,il,tbind([]))= () 
	  | tbindPrint(FH,il,tbind(idtbs))= 	     
	    (
	     printIndent(FH,il+and_width);
	     idTypeBindingsEqualsAndPrint(FH,il,idtbs)
	     )

	and idTypeBindingsEqualsAndPrint(FH,il,idtbs)=
	    ignore
	    (List.foldl (fn(idtb,(_,i))=> 
			 ((
			   (if (i=0) then   
				printIndent(FH,il+and_width)
			    else 
				(printIndent(FH,il); TextIO.output(FH,"\nand ")));
				idTypeBindingEqualsPrint(FH,il+and_width,idtb)),
			  i+1)) 
	     ((),0)  idtbs)

	and idTypeBindingEqualsPrint(FH,il,id_type_binding(id,tp))=
	    (idPrint(FH,il,id);
	     TextIO.output(FH," = ");
	     type'Print(FH,il,tp)
	     )
	    
	and type'Print(FH,il,basetype(id))= idPrint(FH,il,id)
	  | type'Print(FH,il,prodtype(tp,tp')) = 
	    (
	     type'Print(FH,il,tp);
	     TextIO.output(FH," * ");
	     type'Print(FH,il,tp')
	     )

	and dtbindPrint(FH,il,dtbind(dtbl))=
	    dtbindingListAndPrint(FH,il,dtbl)
	    
	and dtbindingListAndPrint(FH,il,dtbl)=
	    ignore
	    (List.foldl (fn(dtb,(_,i))=> 
			 ((
			   (if (i=0) then   
				()
			    else 
				(printIndent(FH,il); TextIO.output(FH,"\nand ")));
				dtbindingEqualsPrint(FH,il+and_width,dtb)),
			  i+1)) 
	     ((),0)  dtbl)

	and dtbindingEqualsPrint(FH,il,dtbinding(id,dtcl))=
	    (
	     idPrint(FH,il,id);
	     TextIO.output(FH," = \n");
	     dtConstructorBarListPrint(FH,il,dtcl)
	     )
	and  dtConstructorBarListPrint(FH,il,dtcl)=
	    ignore
	    (List.foldl (fn(dtc,(_,i))=> 
			 ((
			   (if (i=0) then   
				printIndent(FH,il+bar_width)
			    else 
				( TextIO.output(FH,"\n");printIndent(FH,il); TextIO.output(FH,"| ")));
				dtConstructorPrint(FH,il+bar_width,dtc)),
			  i+1)) 
	     ((),0)  dtcl)

	and dtConstructorPrint(FH,il,dt_constructor_atomic(id)) = idPrint(FH,il,id)
	  | dtConstructorPrint(FH,il,dt_constructor_compound(id,tp)) = 
	    (
	     idPrint(FH,il,id);
	     TextIO.output(FH," of ");
	     type'Print(FH,il,tp)
	     )

	and idTypeBindingsOfAndPrint(FH,il,idtbs) = 
	    ignore
	    (List.foldl (fn(idtb,(_,i))=> 
			 ((
			   (if (i=0) then   
				printIndent(FH,il+and_width)
			    else 
				(printIndent(FH,il); TextIO.output(FH,"\nand ")));
				idTypeBindingOfPrint(FH,il+and_width,idtb)),
			  i+1)) 
	     ((),0)  idtbs)
	    
	and idTypeBindingOfPrint(FH,il,id_type_binding(id,tp))=
	    (
	     idPrint(FH,il,id);
	     TextIO.output(FH," of ");
	     type'Print(FH,il,tp)
	     )

	and idsAndPrint(FH,il,ids)=
	    ignore
	    (List.foldl (fn(id,(_,i))=> 
			 ((
			   (if (i=0) then   
				printIndent(FH,il+and_width)
			    else 
				(printIndent(FH,il); TextIO.output(FH,"and ")));
				idPrint(FH,il,id)),
			  i+1)) 
	     ((),0)  ids)

	and idsCommaPrint(FH,il,ids)=
	    ignore
	    (List.foldl (fn(id,(_,i))=> 
			 ((
			   (if (i=0) then   
				()
			    else 
				(TextIO.output(FH,", ")));
				idPrint(FH,il,id)),
			  i+1)) 
	     ((),0)  ids)
	    
	and idPrint(FH,il,id)=TextIO.output(FH,id)

	and patExpBindingsEqualsAndPrint(FH,il,pebs)=
	    ignore
	    (List.foldl (fn(peb,(_,i))=> 
			 ((
			   (if (i=0) then   
				()
			    else 
				(TextIO.output(FH,"\n");printIndent(FH,il); TextIO.output(FH,"and ")));
				patExpBindingEqualsPrint(FH,il+and_width,peb)),
			  i+1)) 
	     ((),0)  pebs)
	
	and patExpBindingEqualsPrint(FH,il,pat_exp_binding(p,e))=
	    (
	     patPrint(FH,il,p);
	     TextIO.output(FH," = ");
	     expPrint(FH,il+ind_width,e)
	     )
	    
	and patPrint(FH,il,pat_atomic(apt))= apatPrint(FH,il,apt)
	  | patPrint(FH,il,pat_compound(id,apt))=
	    (
	     idPrint(FH,il,id);
	     TextIO.output(FH," ");
	     apatPrint(FH,il,apt)
	     )

	and apatPrint(FH,il,apat_ident(id))=idPrint(FH,il,id)
	  | apatPrint(FH,il,apat_const(c))= constPrint(FH,il,c)
	  | apatPrint(FH,il,apat_any)=TextIO.output(FH,"_")
	  | apatPrint(FH,il,apat_tuple(pts))=
	    (
	      TextIO.output(FH,"( ");
	      patListCommaPrint(FH,il,pts);
	      TextIO.output(FH," )")
	     )

	and patListCommaPrint(FH,il,pts)=
	    ignore
	    (List.foldl (fn(pt,(_,i))=> 
			 ((
			   (if (i=0) then   
				()
			    else 
				(TextIO.output(FH,", ")));
				patPrint(FH,il,pt)),
			  i+1)) 
	     ((),0)  pts)
	
	and expPrint(FH,il,skip) = TextIO.output(FH,"()") 
	    
	  | expPrint(FH,il,const(c)) = constPrint(FH,il,c)
	    
	  | expPrint(FH,il,var(id)) = idPrint(FH,il,id)
 
	  | expPrint(FH,il,if_else(e1,e2,e3)) = 
	    (TextIO.output(FH,"if ");
	     expPrint(FH,il+ind_width,e1);
	     TextIO.output(FH," then\n");
	     printIndent(FH,il+ind_width);
	     expPrint(FH,il+ind_width,e2);
	     TextIO.output(FH,"\n");
	     printIndent(FH,il);
	     TextIO.output(FH,"else\n");
	     printIndent(FH,il+ind_width);
	     expPrint(FH,il+ind_width,e3);
	     TextIO.output(FH,"\n")
	     )
	    
	  | expPrint(FH,il,tuple(es))=
	    (
	      TextIO.output(FH,"( ");
	      expListCommaPrint(FH,il,es);
	      TextIO.output(FH," )")
	     )

	  | expPrint(FH,il,let_in(dcs,e)) = 
	    (printIndent(FH,il);
	     TextIO.output(FH,"let ");
	     decsSemiColonPrint(FH,il+let_width,dcs);
	     TextIO.output(FH,"\n");
	     printIndent(FH,il);
	     TextIO.output(FH,"in\n");
	     printIndent(FH,il+ind_width);
	     expPrint(FH,il+ind_width,e);
	     TextIO.output(FH,"\n");
	     printIndent(FH,il);
	     TextIO.output(FH,"end")
	     )
	  | expPrint(FH,il,case_of(e,m)) = 
	    (printIndent(FH,il);
	     TextIO.output(FH,"(case ");
	     expPrint(FH,il+ind_width,e);
	     TextIO.output(FH," of\n");
	     matchPrint(FH,il+ind_width,m);
	     TextIO.output(FH,")")
	     )
	    
	  | expPrint(FH,il,primop(opr,e)) = 
	    (primopPrint(FH,il,opr);	     
	     expPrint(FH,il+ind_width,e)
	     )
	    
	  | expPrint(FH,il,call(e,e')) = 
	    (
	     TextIO.output(FH," ( ");
	     expPrint(FH,il,e);	     
	     TextIO.output(FH," ");
	     expPrint(FH,il,e');
	     TextIO.output(FH," ) ")
	     )
	    
	  | expPrint(FH,il,anon_fun(ids,ex))=
	    (
	     TextIO.output(FH,"fn (");
	     idsCommaPrint(FH,il,ids);
	     TextIO.output(FH," ) =>");	      
		 expPrint(FH,il,ex)
		 )
	    
	  | expPrint(FH,il,exp_andalso(e,e'))=
	    (
	     expPrint(FH,il,e);
	     TextIO.output(FH," andalso \n");
	     expPrint(FH,il,e')
	     )
	  | expPrint(FH,il,exp_orelse(e,e'))=
	     (
	     expPrint(FH,il,e);
	     TextIO.output(FH," orelse \n");
	     expPrint(FH,il,e')
	     )
	  | expPrint(FH,il,curried_call(id,e::es))=
	     (
	      let val es' = List.rev(es) in
		  curriedCallPrint(FH,il,id,es')
	      end
	      )
	     
	and curriedCallPrint(FH,il,id,[e])=
	    (TextIO.output(FH,"( ");
	     TextIO.output(FH,id^" ");
	     expPrint(FH,il,e);
	     TextIO.output(FH," )")
	     )
	  | curriedCallPrint(FH,il,id,e::es)=
	    (
	     TextIO.output(FH,"( ");
	     curriedCallPrint(FH,il,id,es);
	     TextIO.output(FH," ");
	     expPrint(FH,il,e);
	     TextIO.output(FH," )")
	     )
	     
	and matchPrint(FH,il,match(pebs))= patExpBindingsEqualGtBarPrint(FH,il,pebs)
	and patExpBindingsEqualGtBarPrint(FH,il,pebs)=
	    ignore
	    (List.foldl (fn(peb,(_,i))=> 
			 ((
			   (if (i=0) then   
				printIndent(FH,il+bar_width)
			    else 
				(TextIO.output(FH,"\n"); printIndent(FH,il); TextIO.output(FH,"| ")));
				patExpBindingEqualsGtPrint(FH,il,peb)),
			  i+1)) 
	     ((),0)  pebs)
	    
	and patExpBindingEqualsGtPrint(FH,il,pat_exp_binding(p,e))=
	    (
	     patPrint(FH,il,p);
	     TextIO.output(FH," => \n");
		 (if expIsSelfIndenting(e) then 
		      ()  
		  else 
		      printIndent(FH,il+ind_width));
		      expPrint(FH,il+ind_width,e)
		      )
	    
	and expIsSelfIndenting(let_in _) = true
	  | expIsSelfIndenting(case_of _) = true
	  | expIsSelfIndenting _ = false
	    	    
	and  expListCommaPrint(FH,il,es)=
	    ignore
	    (List.foldl (fn(e,(_,i))=> 
			 ((
			   (if (i=0) then   
				()
			    else 
				(TextIO.output(FH,", ")));
				expPrint(FH,il+ind_width,e)),
			  i+1)) 
	     ((),0)  es)
	    
	and decsSemiColonPrint(FH,il,dcs)=
	    ignore
	    (List.foldl (fn(dc,(_,i))=> 
			 ((
			   (if (i=0) then   
				()
			    else 
				(TextIO.output(FH,";\n");printIndent(FH,il)));
				decPrint(FH,il,dc)),
			  i+1)) 
	     ((),0)  dcs)
	    
	and constPrint(FH,il,int(i))=TextIO.output(FH,Int.toString(i))
	  | constPrint(FH,il,bool(b))=TextIO.output(FH,Bool.toString(b))	    
	  | constPrint(FH,il,string(s))=TextIO.output(FH,"\"" ^ s ^ "\"")
	    
	and primopPrint (FH,il,opr) = 
	    let val s =	primopToString(opr)	    
	    in
		TextIO.output(FH,s)
	    end
	
			       and printIndent(FH,il) =
				   if il=0 then TextIO.output(FH,"")
				   else (TextIO.output(FH," "); printIndent(FH,il-1))
				       
			       and primopToString(opr)=
				   case opr of
				       op_neg 	=>  "~" 
				     | op_not 	=>  "not" 
				     | op_div 	=>  "(op div)" 
				     | op_mod 	=>  "(op mod)" 
				     | op_times 	=>  "op *" 
				     | op_plus 	=>  "(op +)" 
				     | op_minus 	=>  "(op -)" 
				     | op_lt 	=>  "(op <)" 
				     | op_leq 	=>  "(op <=)" 
				     | op_gt 	=>  "(op >)" 
				     | op_geq 	=>  "(op >=)" 
				     | op_equal 	=>  "(op =)" 
				     | op_notequal	=>  "(op <>)"
				     | op_lshift 	=>  "lshift" 
				     | op_rshift 	=>  "rshift" 
				     | op_andb 	=>  "andb"
				     | op_orb 	=>  "orb" 
				     | op_xorb 	=>  "xorb" 
					   
					   
    end


